/**
 * @module package/quiqqer/login-logger/bin/controls/DashboardCards/LatestLogins
 * @author www.pcsg.de (Jan Wennrich)
 */
define('package/quiqqer/login-logger/bin/controls/DashboardCards/LatestLogins', [

    'Ajax',
    'Locale',
    'Mustache',

    'package/quiqqer/dashboard/bin/backend/controls/Card',
    'package/quiqqer/login-logger/bin/classes/Utils',

    'utils/Panels',
    'package/quiqqer/login-logger/bin/controls/Panel',

    'text!package/quiqqer/login-logger/bin/controls/DashboardCards/LatestLogins/content.html'

], function (QUIAjax, QUILocale, Mustache, QUICard, UtilsClass, PanelUtils, LoginLoggerPanel, template) {
    "use strict";

    var lg = 'quiqqer/dashboard';

    var Utils = new UtilsClass();

    return new Class({

        Extends: QUICard,
        Type   : 'package/quiqqer/login-logger/bin/controls/DashboardCards/LatestLogins',

        initialize: function (options) {
            this.parent(options);

            this.setAttributes({
                id      : 'quiqqer-dashboard-card-latest-logins',
                icon    : 'fa fa-sign-in',
                title   : QUILocale.get(lg, 'dashboard.logins'),
                content : Mustache.render(template, {
                    date      : QUILocale.get('quiqqer/login-logger', 'table.header.date'),
                    username  : QUILocale.get('quiqqer/login-logger', 'table.header.username'),
                    ip        : QUILocale.get('quiqqer/login-logger', 'table.header.ip'),
                    successful: QUILocale.get('quiqqer/login-logger', 'table.header.successful'),
                    type      : QUILocale.get('quiqqer/login-logger', 'table.header.type')
                }),
                footer  : false,
                priority: 70,
                size    : 30,
                styles: {
                    cursor: 'pointer'
                }
            });
        },

        refresh: function () {
            var self = this;
            QUIAjax.get('package_quiqqer_login-logger_ajax_getLatestLogins', function (result) {
                result = Utils.convertSuccessStatusToIconElement(result);

                self.getElm().addEvent('click', function () {
                    PanelUtils.openPanelInTasks(new LoginLoggerPanel());
                });

                var Tbody = self.getElm().getElement('tbody');

                for (var i = 0, len = result.length; i < len; i++) {
                    var entry = result[i];

                    new Element('tr', {
                        'class'   : 'can-be-hovered',
                        'data-uid': entry.uid,
                        html      : '' +
                                    '<td>' + entry.date + '</td>' +
                                    '<td>' + entry.username + '</td>' +
                                    '<td>' + entry.ip + '</td>' +
                                    '<td>' + entry.successful.outerHTML + '</td>' +
                                    '<td>' + entry.type + '</td>'
                    }).inject(Tbody);
                }
            }, {
                'package': 'quiqqer/login-logger',
                onError  : console.error
            });
        }
    });
});